function [f, df] =  CG_tNCA(VV, Dim, XX, labels, alpha)
% XX contains data, VV contains starting location
% Dim contains dimension
% Copyright Martin Renqiang Min 2009

fprintf(1,'CG_tNCA called\n');
% t4 = clock;
l1 = Dim(1);
l2 = Dim(2);
l3 = Dim(3);
l4= Dim(4);
l5= Dim(5);
l6= Dim(6);
l7= Dim(7);
l8= Dim(8);
l9= Dim(9);
N = size(XX,1);
n = N;

% Do deconversion.
 w1 = reshape(VV(1:(l1+1)*l2),l1+1,l2);
 xxx = (l1+1)*l2;
 w2 = reshape(VV(xxx+1:xxx+(l2+1)*l3),l2+1,l3);
 xxx = xxx+(l2+1)*l3;
 w3 = reshape(VV(xxx+1:xxx+(l3+1)*l4),l3+1,l4);
 xxx = xxx+(l3+1)*l4;
 w4 = reshape(VV(xxx+1:xxx+(l4+1)*l5),l4+1,l5);
 xxx = xxx+(l4+1)*l5;
 w5 = reshape(VV(xxx+1:xxx+(l5+1)*l6),l5+1,l6);
 xxx = xxx+(l5+1)*l6;
 w6 = reshape(VV(xxx+1:xxx+(l6+1)*l7),l6+1,l7);
 xxx = xxx+(l6+1)*l7;
 w7 = reshape(VV(xxx+1:xxx+(l7+1)*l8),l7+1,l8);
 xxx = xxx+(l7+1)*l8;
 w8 = reshape(VV(xxx+1:xxx+(l8+1)*l9),l8+1,l9);


  XX = [XX ones(N,1)];
  w1probs = 1./(1 + exp(-XX*w1)); w1probs = [w1probs  ones(N,1)];
  w2probs = 1./(1 + exp(-w1probs*w2)); w2probs = [w2probs ones(N,1)];
  w3probs = 1./(1 + exp(-w2probs*w3)); w3probs = [w3probs  ones(N,1)];
  w4probs = w3probs*w4; w4probs = [w4probs  ones(N,1)];
  
  % comment out upper layers for autoencoder
  %w5probs = 1./(1 + exp(-w4probs*w5)); w5probs = [w5probs  ones(N,1)];
  %w6probs = 1./(1 + exp(-w5probs*w6)); w6probs = [w6probs  ones(N,1)];
  %w7probs = 1./(1 + exp(-w6probs*w7)); w7probs = [w7probs  ones(N,1)];
  %XXout = 1./(1 + exp(-w7probs*w8));

w5probs = eye(N, l6+1);
w6probs = eye(N, l7+1);
w7probs = eye(N, l8+1);
XXout = eye(N, l9);

ydata = w4probs(:,1:(size(w4probs, 2)-1));
    Y = ydata;
    clear ydata;
    sqYnorm = sum(Y .^ 2, 2);
    Dist = - bsxfun(@minus, bsxfun(@minus, 2 * Y * Y', sqYnorm'), sqYnorm);
    Dist = Dist + eye(size(Dist))*exp(200);
    invDist = 1./(1 + Dist/alpha);
    invDist = max(invDist, eps);
    clear Dist;

    P = invDist.^(0.5 + alpha/2);
    P(1:n+1:end) = 0;
    P = bsxfun(@rdivide, P, sum(P, 2));
    P = max(P, eps);

    % Compute value of cost function
    Pi = zeros(n, 1);
    for i=1:n
        Pi(i) = sum(P(i, labels == labels(i)));
    end
    C = sum(Pi);

    % Compute gradient with respect to the low-dimensional coordinates
    Ix = zeros(n, size(Y, 2));
    for i=1:n
        ind = find(labels == labels(i));
        D = bsxfun(@minus, Y(i,:), Y);
        Pji = bsxfun(@times, bsxfun(@times, P(:,i), D), invDist(:,i)); %% 1/(1+d_ji/alpha)*P_ji
        Pij = bsxfun(@times, bsxfun(@times, P(i,:)', D), invDist(i,:)'); %% 1/(1+d_ij/alpha)*P_ij
        Ix(i,:) = - sum(Pji(ind,:), 1) + sum(bsxfun(@times, Pi, Pji), 1) + ...
                  - sum(Pij(ind,:), 1) + Pi(i) * sum(Pij, 1);
    end
    Ix = Ix * (1 + alpha)/alpha;

    C = -C;
	
f = C;

%IO = lambda1*1/N*(XXout-XX(:,1:end-1));
%Ix8=IO; 
dw8 =  eye(l8+1, l9);
                                                % Does back propagation to
                                                % get dw's
%Ix7 = (Ix8*w8').*w7probs.*(1-w7probs); 
%Ix7 = Ix7(:,1:end-1);
dw7 =  eye(l7+1,l8);

%Ix6 = (Ix7*w7').*w6probs.*(1-w6probs); 
%Ix6 = Ix6(:,1:end-1);
dw6 =  eye(l6+1,l7);

%Ix5 = (Ix6*w6').*w5probs.*(1-w5probs); 
%Ix5 = Ix5(:,1:end-1);
dw5 =  eye(l5+1,l6);


% Ix4 = (Ix5*w5');
% Ix4 = Ix4(:,1:end-1);
% Ix4 = Ix4(:,1:end-1) + new_code_grad*lambda2;
 
% NCA cost
Ix4 = -Ix;

dw8=dw8*0;dw7=dw7*0;dw6=dw6*0;dw5=dw5*0;% Uncomment to turn off reconstructive tuning
dw4 =  w3probs'*Ix4;


Ix3 = (Ix4*w4').*w3probs.*(1-w3probs); 
Ix3 = Ix3(:,1:end-1);
dw3 =  w2probs'*Ix3;

Ix2 = (Ix3*w3').*w2probs.*(1-w2probs); 
Ix2 = Ix2(:,1:end-1);
dw2 =  w1probs'*Ix2;

Ix1 = (Ix2*w2').*w1probs.*(1-w1probs); 
Ix1 = Ix1(:,1:end-1);
dw1 =  XX'*Ix1;



df = [dw1(:)' dw2(:)' dw3(:)' dw4(:)' dw5(:)' dw6(:)'  dw7(:)'  dw8(:)'  ]';    % Returns vector of partial derivatives WRT the weights

