% Version 1.000
% adapted from Geoff Hinton's Science 2006 paper code 
% Renqiang Min copyright 2009
% for minbatch training on MNIST


% for dGMCML
if restart == 1

 %makebatches_USPS;
 %makebatches_MNIST;

 load MNIST_batchdata;
 nologistic = 1;  

 minimizetimes = [];
 maxepoch=100; % 200


 [numcases numdims numbatches]=size(batchdata);
 fprintf(1, 'there are %d batches of data with size %d\n', numbatches, numcases);
 N=numcases; 


  initmaxepoch=50;
  NUMHID=500
  numpen=500
  numpen2=2000
  numopen=30
  numopen1=30
  load(['mnistvh' '_' int2str(NUMHID) '_' int2str(numpen) '_' int2str(numpen2) '_' int2str(numopen) 'ep' '_' int2str(initmaxepoch)])
  load(['mnisthp' '_' int2str(NUMHID) '_' int2str(numpen) '_' int2str(numpen2) '_' int2str(numopen) 'ep' '_' int2str(initmaxepoch)])
  load(['mnisthp2' '_' int2str(NUMHID) '_' int2str(numpen) '_' int2str(numpen2) '_' int2str(numopen) 'ep' '_' int2str(initmaxepoch)])
  load(['mnistpo' '_' int2str(NUMHID) '_' int2str(numpen) '_' int2str(numpen2) '_' int2str(numopen1) 'ep' '_' int2str(initmaxepoch)])

  test_err=[];
  train_err=[];


max_iter=20
k = 5

end


%%%% PREINITIALIZE WEIGHTS OF THE AUTOENCODER %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if restart == 1
    w1=[vishid; hidrecbiases];
    w2=[hidpen; penrecbiases];
    w3=[hidpen2; penrecbiases2];
    w4=[hidtop; toprecbiases];
    w5=[hidtop'; topgenbiases]; 
    w6=[hidpen2'; hidgenbiases2]; 
    w7=[hidpen'; hidgenbiases]; 
    w8=[vishid'; visbiases];
end

%%%%%%%%%% END OF PREINITIALIZATIO OF WEIGHTS  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

l1=size(w1,1)-1;
l2=size(w2,1)-1;
l3=size(w3,1)-1;
l4=size(w4,1)-1;
l5=size(w5,1)-1;
l6=size(w6,1)-1;
l7=size(w7,1)-1;
l8=size(w8,1)-1;
l9=l1; 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%/////////////////
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Setting Parameters   //////////////////////////////


if (restart)
    starting_epoch = 1;
else
    starting_epoch = length(train_err) + 1;
end

for epoch = starting_epoch:maxepoch

%%%%%%%%%%%%%%%%%%%% COMPUTE KNN CLASSIFICATION ERROR %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
  err=0; 
 if epoch > 1
  data = xTr;
  len_data = size(data,1);
  data = [data ones(len_data,1)];
  w1probs = 1./(1 + exp(-data*w1)); w1probs = [w1probs  ones(len_data,1)];             % We extend the dimensionality
  w2probs = 1./(1 + exp(-w1probs*w2)); w2probs = [w2probs ones(len_data,1)];           % of each level RBM by 1. This is to account
  w3probs = 1./(1 + exp(-w2probs*w3)); w3probs = [w3probs  ones(len_data,1)];          % for the biases, in addition to vishid
  w4probs_tr = w3probs*w4;
  if ~(nologistic)
      w4probs_tr = 1./(1 + exp(-w4probs_tr));  
  end

  data = xTe;
  len_data = size(data,1);
  data = [data ones(len_data,1)];
  w1probs = 1./(1 + exp(-data*w1)); w1probs = [w1probs  ones(len_data,1)];
  w2probs = 1./(1 + exp(-w1probs*w2)); w2probs = [w2probs ones(len_data,1)];
  w3probs = 1./(1 + exp(-w2probs*w3)); w3probs = [w3probs  ones(len_data,1)];
  w4probs_te = w3probs*w4;
  if ~(nologistic)
      w4probs_te = 1./(1 + exp(-w4probs_te));    
  end
  
  
  code_dim = size(w4probs_tr,2);
  fprintf(1,'computing knn err ... \n');
  [Eval Details] = knnclassify (eye(code_dim,code_dim),w4probs_tr,yTr,w4probs_te,yTe,k);
  
  train_err(epoch) = Eval(1)*100;
  test_err(epoch) = Eval(2)*100;
  
 fprintf(1,'Before epoch %d Train error: %6.3f Test error: %6.3f \t \t \n',epoch,train_err(epoch),test_err(epoch));
end
%%%%%%%%%%%%%% END OF COMPUTING KNN CLASSIFICATION ERROR %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 for batch = 1:numbatches
   fprintf(1,'epoch %d batch %d\r',epoch,batch);
   data = batchdata(:,:, batch);
   datatargets = batchtargets(:,:,batch);
   [dataclass junk] = find (datatargets' == 1);


    fprintf(1,'computing batch probs for batch %d...\n', batch);
    bP = zeros(size(data,1), size(data,1))+eps;
    tmpnumclasses = length(unique(dataclass));
    for tmpind=1:tmpnumclasses
      tmpcurrclass = find(dataclass==tmpind);
      bP(tmpcurrclass,tmpcurrclass) = 1;
    end
    bP = (bP + bP')/2;
    bP = bP - diag(diag(bP));
    bP = bP./sum(abs(bP(:)));
%%%%%%%%%%%%%%% PERFORM CONJUGATE GRADIENT WITH max_iter LINESEARCHES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
  VV = [w1(:)' w2(:)' w3(:)' w4(:)' w5(:)' w6(:)' w7(:)' w8(:)']';  % Make one long row vector of weights
  Dim = [l1; l2; l3; l4; l5; l6; l7; l8; l9];   % Row vector of lengths


  t1 = clock;

  % if you want to run autoencoder first, use the following line, and comment the line below it
  %[X, fX] = minimize(VV,'CG_autoencoder',max_iter,Dim,data);
  [X, fX] = minimize(VV,'CG_dGMCML',max_iter,Dim,data,bP);
  t2 = clock;
  minimizetimes = [minimizetimes; (t2-t1)];
  

  w1 = reshape(X(1:(l1+1)*l2),l1+1,l2);     % Unrolls the new weights
  xxx = (l1+1)*l2;
  w2 = reshape(X(xxx+1:xxx+(l2+1)*l3),l2+1,l3);
  xxx = xxx+(l2+1)*l3;
  w3 = reshape(X(xxx+1:xxx+(l3+1)*l4),l3+1,l4);
  xxx = xxx+(l3+1)*l4;
  w4 = reshape(X(xxx+1:xxx+(l4+1)*l5),l4+1,l5);
  xxx = xxx+(l4+1)*l5;
  w5 = reshape(X(xxx+1:xxx+(l5+1)*l6),l5+1,l6);
  xxx = xxx+(l5+1)*l6;
  w6 = reshape(X(xxx+1:xxx+(l6+1)*l7),l6+1,l7);
  xxx = xxx+(l6+1)*l7;
  w7 = reshape(X(xxx+1:xxx+(l7+1)*l8),l7+1,l8);
  xxx = xxx+(l7+1)*l8;
  w8 = reshape(X(xxx+1:xxx+(l8+1)*l9),l8+1,l9);

%%%%%%%%%%%%%%% END OF CONJUGATE GRADIENT WITH max_iter LINESEARCHES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 end

 %save mnist_weights w1 w2 w3 w4 w5 w6 w7 w8 
 %save mnist_error test_err train_err minimizetimes;

end



