% For training data:
digitdata = xTr;

totnum = size(digitdata,1);
fprintf(1, 'Size of the training dataset= %5d \n', totnum);

rand('state',0); %so we know the permutation of the training data
randomorder=randperm(totnum);

targets = zeros(totnum,10);
for i = 1:totnum
    targets(i,yTr(i)) = 1;
end

numbatches=totnum/batchsize;
numdims  =  size(digitdata,2);                      % Computes the number of pixels in each image
batchdata = zeros(batchsize, numdims, numbatches);  % 100 rows of batches x 256 x numbatches
batchtargets = zeros(batchsize, 10, numbatches);

for b=1:numbatches                                  % Populate batches
  batchdata(:,:,b) = digitdata(randomorder(1+(b-1)*batchsize:b*batchsize), :);
  batchtargets(:,:,b) = targets(randomorder(1+(b-1)*batchsize:b*batchsize), :);
end;
clear digitdata targets;



%%% Reset random seeds 
rand('state',sum(100*clock)); 
randn('state',sum(100*clock)); 
